////////////////////////////////////////////////////////////////////////////////
///                            GLNormalRenderer.h                            ///
////////////////////////////////////////////////////////////////////////////////

#ifndef GLNORMALRENDERER_H
#define GLNORMALRENDERER_H

#include "GLNormalRendererGlobalVariables.h"

#include <X3DTK/glscenegraph.h>

namespace X3DTK {
namespace GL {

/// GLNormalRenderer module.

class NormalRenderer : public X3DOnePassProcessor
{
public:
  /// Constructor.
  NormalRenderer();
  /// Destructor.
  virtual ~NormalRenderer();
  
  /// Sets the length of the normals.
  void setNormalLength(float value);
    
  /// Renders a GLScene.
  virtual void render(SFNode N) const;

protected:
  NormalRendererGlobalVariables *globalVariables;
};

}
}

#endif
