#include "GLNormalRendererGroupingVisitor.h"

namespace X3DTK {
namespace GL {

NormalRendererGroupingVisitor::NormalRendererGroupingVisitor()
: GroupingVisitor()
{
  // Enter functions.
  defineNewEnterFunction(&NormalRendererGroupingVisitor::enterTransform);

  // Leave functions
  defineNewLeaveFunction(&NormalRendererGroupingVisitor::leaveTransform);
}

NormalRendererGroupingVisitor::~NormalRendererGroupingVisitor()
{
}

void NormalRendererGroupingVisitor::enterTransform(Transform *T) const
{
  // Changing the coordinates system.
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glMultMatrixf(&T->getTransformMatrix().front());
}

void NormalRendererGroupingVisitor::leaveTransform(Transform *T) const
{
  // Returning to the old coordinates system.
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();  
}

}
}
