#include "MyBBoxUpdaterGeometry3DVisitor.h"
#include "Icosahedron.h"

#include <iostream>
using namespace std;

namespace X3DTK {
namespace X3D {

MyBBoxUpdaterGeometry3DVisitor::MyBBoxUpdaterGeometry3DVisitor()
: BBoxUpdaterGeometry3DVisitor()
{
  // Defines the new enter function for the X3DAbstractNode.
  defineNewEnterFunction(&MyBBoxUpdaterGeometry3DVisitor::enterIcosahedron);
  
  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<BBoxUpdaterGlobalVariables>();
}

void MyBBoxUpdaterGeometry3DVisitor::enterIcosahedron(Icosahedron *I) const
{
  // Checking whether the BBox of the node has already been computed.
  BBox *BB = globalVariables->getBBox(I);
  if (BB == 0)
  {
    BB = new BBox(SFVec3f(0.0f, 0.0f, 0.0f), SFVec3f(2.0f*I->getRadius(), 2.0f*I->getRadius(), 2.0f*I->getRadius()));
    globalVariables->addBBox(I, BB);
    globalVariables->setShapeBBox(*BB);
  }
}

}
}
