////////////////////////////////////////////////////////////////////////////////
///                            InfoReaderGroupingVisitor.h                   ///
////////////////////////////////////////////////////////////////////////////////

#ifndef INFOREADERGROUPINGVISITOR_H
#define INFOREADERGROUPINGVISITOR_H

#include <X3DTK/x3dscenegraph.h>

namespace X3DTK {
namespace X3D {

class Info;
class Price;
class Modeler;

/// Visitor for the Grouping component of the InfoReader module.

class InfoReaderGroupingVisitor : public GroupingVisitor
{
public:
  /// Constructor.
  InfoReaderGroupingVisitor();
  /// Destructor.
  virtual ~InfoReaderGroupingVisitor();

  /// Enters an Info.
  virtual void enterInfo(Info *I) const;
  /// Enters a Price.
  virtual void enterPrice(Price *P) const;
  /// Enters a Modeler.
  virtual void enterModeler(Modeler *M) const;
};

}
}

#endif
