#include "MyDFSGroupingWalker.h"
#include "Info.h"
#include "Price.h"
#include "Modeler.h"

#include <iostream>
using namespace std;

namespace X3DTK {
namespace X3D {

MyDFSGroupingWalker::MyDFSGroupingWalker()
: DFSGroupingWalker()
{
  defineNewWalkingFunction(&MyDFSGroupingWalker::walkInfo);
}

MyDFSGroupingWalker::~MyDFSGroupingWalker()
{
}

void MyDFSGroupingWalker::walkInfo(Info *I) const
{
  visitor->enter(I);
  
  SFNode N = I->getPrice();
  if ((N != 0) && (visitor->walkOn(I, N)))
    walker->walk(N);
  
  N = I->getModeler();
  if ((N != 0) && (visitor->walkOn(I, N)))
    walker->walk(N);  
  
  visitor->leave(I);
}

}
}
