#include "MeshTransformComputer.h"
#include "MeshTransformComputerCoreVisitor.h"

namespace X3DTK {
namespace MESH {

MeshTransformComputer::MeshTransformComputer()
{
  globalVariables = GVManager::getInstanceOf<MeshTransformComputerGlobalVariables>();
    
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new MeshTransformComputerCoreVisitor());
}

MeshTransformComputer::~MeshTransformComputer()
{
  GVManager::removeInstanceOf<MeshTransformComputerGlobalVariables>();

  delete graphTraversal;
}

void MeshTransformComputer::print(SFNode N)
{
  globalVariables->init();
  graphTraversal->traverse(N);
  globalVariables->finish();
}

}
}

