////////////////////////////////////////////////////////////////////////////////
///                            MeshTransformComputerCoreVisitor.h            ///
////////////////////////////////////////////////////////////////////////////////

#ifndef MESHTRANSFORMCOMPUTERCOREVISITOR_H
#define MESHTRANSFORMCOMPUTERCOREVISITOR_H

#include <X3DTK/meshscenegraph.h>

#include "MeshTransformComputerGlobalVariables.h"

namespace X3DTK {
namespace MESH {

class X3DGroupingNode;
class Transform;

/// Visitor for the Core component of the MeshTransformComputer module.

class MeshTransformComputerCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  MeshTransformComputerCoreVisitor();
  /// Destructor.
  virtual ~MeshTransformComputerCoreVisitor();

  /// Enters a Mesh.
  virtual void enterMesh(Mesh *M) const;

  /// Enters a Transform.
  virtual void enterTransform(Transform *T) const;

  /// Leaves a Scene.
  virtual void leaveX3DGroupingNode(X3DGroupingNode *N) const;

protected:
  MeshTransformComputerGlobalVariables *globalVariables;
};

}
}

#endif
