#include "MeshTransformComputerGlobalVariables.h"

namespace X3DTK {
namespace MESH {

MeshTransformComputerGlobalVariables::MeshTransformComputerGlobalVariables()
: GlobalVariables()
{
}

MeshTransformComputerGlobalVariables::~MeshTransformComputerGlobalVariables()
{
}

void MeshTransformComputerGlobalVariables::init()
{
  _matrixStack.push_front(SFMatrix34f::IDENTITY);
}

void MeshTransformComputerGlobalVariables::finish()
{
  _matrixStack.clear();
}

void MeshTransformComputerGlobalVariables::pushMatrix(const SFMatrix34f &transformation)
{
  _matrixStack.push_front(_matrixStack.front()*transformation);
}

void MeshTransformComputerGlobalVariables::popMatrix()
{
  _matrixStack.pop_front();
}

}
}
