#include "MyMemReleaserAbstractVisitor.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

MyMemReleaserAbstractVisitor::MyMemReleaserAbstractVisitor()
: MemReleaserAbstractVisitor()
{
  // Defines the new enter function for the X3DAbstractNode.
  defineNewEnterFunction(&MyMemReleaserAbstractVisitor::enterX3DAbstractNode);
  // Defines the new enter function for the Cylinder. This method will not be recorded 
  // because Cylinder doesn't belong to the Abstract component.
  defineNewEnterFunction(&MyMemReleaserAbstractVisitor::enterCylinder);
}

void MyMemReleaserAbstractVisitor::enterX3DAbstractNode(X3DAbstractNode *N) const
{
  // Prints the name of the node.
  cout << N->getTypeName() << " released " << endl;
  MemReleaserAbstractVisitor::enterX3DAbstractNode(N);
}

void MyMemReleaserAbstractVisitor::enterCylinder(X3D::Cylinder *C) const
{
  // empty because it will never be called.
}

