////////////////////////////////////////////////////////////////////////////////
///                           MySimpleMesh.h                                 ///
////////////////////////////////////////////////////////////////////////////////

#ifndef MYSIMPLEMESH_H
#define MYSIMPLEMESH_H

#include <vector>
#include <list>

typedef struct _Vertex
{
  float x;
  float y;
  float z;
} Vertex;

typedef std::list<unsigned int> Face;

class MySimpleMesh
{
public:
  MySimpleMesh();
  ~MySimpleMesh();
  
  void addVertex(float x, float y, float z);
  void addFace(const std::list<unsigned int> &indexes);
  void print() const;
  
  inline std::vector<Vertex> &getVertexArray() {return _vertexArray;};
  inline std::vector<Face> &getIndexArray() {return _indexArray;};
  
private:
  std::vector<Vertex> _vertexArray;
  std::vector<Face> _indexArray;
};

#endif
