#include "MyStructureComputer.h"
#include "MyStructureComputerCoreVisitor.h"

namespace X3DTK {
namespace MESH {

MyStructureComputer::MyStructureComputer()
{
  globalVariables = GVManager::getInstanceOf<MyStructureComputerGlobalVariables>();
    
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new MyStructureComputerCoreVisitor());
}

MyStructureComputer::~MyStructureComputer()
{
  GVManager::removeInstanceOf<MyStructureComputerGlobalVariables>();

  delete graphTraversal;
}

MySimpleMesh *MyStructureComputer::compute(SFNode N)
{
  globalVariables->init();
  graphTraversal->traverse(N);
  globalVariables->finish();
  
  return globalVariables->getMesh();
}

}
}

