#include "MyStructureComputerGlobalVariables.h"

namespace X3DTK {
namespace MESH {

MyStructureComputerGlobalVariables::MyStructureComputerGlobalVariables()
: GlobalVariables(), _mesh(0), _decal(0)
{
}

MyStructureComputerGlobalVariables::~MyStructureComputerGlobalVariables()
{
}

void MyStructureComputerGlobalVariables::init()
{
  _mesh = new MySimpleMesh();
  _matrixStack.push_front(SFMatrix34f::IDENTITY);
}

void MyStructureComputerGlobalVariables::finish()
{
  _matrixStack.clear();
}

void MyStructureComputerGlobalVariables::beginNewMesh()
{
  _decal = _mesh->getVertexArray().size();
}

void MyStructureComputerGlobalVariables::addFace(const Face &face)
{
  Face decalFace = face;
  for (Face::iterator it = decalFace.begin(); it != decalFace.end(); ++it)
    *it = _decal + *it;
    
  _mesh->addFace(decalFace);
};

void MyStructureComputerGlobalVariables::pushMatrix(const SFMatrix34f &transformation)
{
  _matrixStack.push_front(_matrixStack.front()*transformation);
}

void MyStructureComputerGlobalVariables::popMatrix()
{
  _matrixStack.pop_front();
}

}
}
