////////////////////////////////////////////////////////////////////////////////
//                            Viewer.h                                        //
////////////////////////////////////////////////////////////////////////////////

#ifndef VIEWER_H
#define VIEWER_H

#include <QGLViewer/qglviewer.h>
#include "NormalX3DGLScene.h"

/// Class providing a Viewer implementing QGLViewer.

class Viewer : public QGLViewer
{
public:
  /// Constructor.
  Viewer(const char *file);
  /// Destructor.
  ~Viewer();
  
protected :
  void loadFile();
  void keyPressEvent(QKeyEvent *e);
  /// Initializes the Viewer.
  void init();
  /// Draws the scene graph.
  void draw();
  
private:
  float normLength;
  X3DTK::NormalX3DGLScene scene;
  X3DTK::Bbox BB;
  char *x3dfile;
  bool normal;
};

#endif
