////////////////////////////////////////////////////////////////////////////////
//                            Icosahedron.h                                   //
////////////////////////////////////////////////////////////////////////////////

#ifndef ICOSAHEDRON_H
#define ICOSAHEDRON_H

#include <X3DTK/kernel.h>

namespace X3DTK {
namespace X3D {

class Icosahedron : public X3DGeometry3DNode
{
public:
  // Constructor.
  Icosahedron();
  // Constructs a Cylinder from its attributes.
  Icosahedron(SFFloat radius);
            
  // Clones the node.
  virtual SFNode clone() const;  
  // sets the number of sections.
  void setRadius(SFFloat radius);

  // gets the number of sections.
  inline SFFloat getRadius() const {return _radius;};
  
  // Loads the attributes from a X3DFileElement e.
  virtual void load(const X3DFileElement *element);
  // Writes the attributes of the node.
  virtual SFString write() const;

protected:
  // Copy constructor.	   
  Icosahedron(const Icosahedron &I);

private:
  SFFloat _radius;
};

}
}

#endif
