#include "MyBboxUpdaterGeometry3DVisitor.h"
#include "Icosahedron.h"

#include <iostream>

namespace X3DTK {
namespace X3D {

MyBboxUpdaterGeometry3DVisitor::MyBboxUpdaterGeometry3DVisitor()
: BboxUpdaterGeometry3DVisitor()
{
  // Defines the new enter function for the X3DAbstractNode.
  defineNewEnterFunction<MyBboxUpdaterGeometry3DVisitor, Icosahedron>(&MyBboxUpdaterGeometry3DVisitor::enterIcosahedron);
  
  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<BboxUpdaterGlobalVariables>();
}

void MyBboxUpdaterGeometry3DVisitor::enterIcosahedron(Icosahedron *I) const
{
  Bbox *BB = globalVariables->getBbox(I);
  if (BB == 0)
  {
    BB = new Bbox(SFVec3f(0.0f, 0.0f, 0.0f), SFVec3f(2.0f*I->getRadius(), 2.0f*I->getRadius(), 2.0f*I->getRadius()));
    globalVariables->addBbox(I, BB);
    globalVariables->setShapeBbox(*BB);  
  }
}

}
}
