////////////////////////////////////////////////////////////////////////////////
//                            Modeler.h                                       //
////////////////////////////////////////////////////////////////////////////////

#ifndef MODELER_H
#define MODELER_H

#include <X3DTK/kernel.h>

namespace X3DTK {
namespace X3D {

class Modeler : public X3DChildNode
{
public:
  // Constructor.
  Modeler();
  // Constructs a Cylinder from its attributes.
  Modeler(const SFString &name);
            
  // Clones the node.
  virtual SFNode clone() const;  
  // sets the date.
  void setName(const SFString &name);

  // gets the name.
  inline SFString getName() const {return _name;};
 
  // Loads the attributes from a X3DFileElement e.
  virtual void load(const X3DFileElement *element);
  // Writes the attributes of the node.
  virtual SFString write() const;

protected:
  // Copy constructor.	   
  Modeler(const Modeler &I);

private:
  SFString _name;
};

}
}

#endif
