////////////////////////////////////////////////////////////////////////////////
//                            Price.h                                         //
////////////////////////////////////////////////////////////////////////////////

#ifndef PRICE_H
#define PRICE_H

#include <X3DTK/kernel.h>

namespace X3DTK {
namespace X3D {

class Price : public X3DChildNode
{
public:
  // Constructor.
  Price();
  // Constructs a Cylinder from its attributes.
  Price(SFFloat price,
        const SFString &money);
            
  // Clones the node.
  virtual SFNode clone() const;  
  // sets the date.
  void setPrice(SFFloat price);
  // sets the date.
  void setMoney(const SFString &money);

  // gets the price.
  inline SFFloat getPrice() const {return _price;};
  // sets the money.
  inline SFString getMoney() const {return _money;};
 
  // Loads the attributes from a X3DFileElement e.
  virtual void load(const X3DFileElement *element);
  // Writes the attributes of the node.
  virtual SFString write() const;

protected:
  // Copy constructor.	   
  Price(const Price &I);

private:
  SFFloat _price;
  SFString _money;
};

}
}

#endif
