#include "GLSimpleAnimator.h"
#include "GLSimpleAnimatorGeometry3DVisitor.h"

namespace X3DTK {
namespace GL {

SimpleAnimator::SimpleAnimator()
: X3DTTAlgorithm()
{
  //Getting the global variables.
  globalVariables = GVManager::getInstanceOf<SimpleAnimatorGlobalVariables>();
    
  dfs = new DefaultDFS();
  dfs->setComponentVisitor(new SimpleAnimatorGeometry3DVisitor());
}

SimpleAnimator::~SimpleAnimator()
{
  delete dfs;
}

void SimpleAnimator::setBboxSize(const SFVec3f &size)
{
  globalVariables->setBboxSize(size);
}

void SimpleAnimator::animate(SFNode N, float time)
{
  // Setting the time.
  globalVariables->setTime(time);
  dfs->traverse(N);
}

}
}
