////////////////////////////////////////////////////////////////////////////////
//                            SimpleAnimationScene.h                          //
////////////////////////////////////////////////////////////////////////////////

#ifndef SIMPLEANIMATIONSCENE_H
#define SIMPLEANIMATIONSCENE_H

#include <X3DTK/simplex3dglscene.h>
#include <X3DTK/worldcoordtranslator.h>
#include "GLSimpleAnimator.h"

namespace X3DTK {

/// Class providing the animation and the loading of an X3D model.

class SimpleAnimationScene : public SimpleX3DGLScene
{
public:
  /// Constructor.
  SimpleAnimationScene();
  /// Destructor.
  virtual ~SimpleAnimationScene();
  
  /// Loads the file.
  virtual void load(const char *file, bool fileValidation = true);
  /// Initializes the animation.
  virtual void init();
  /// Animates the scene.
  virtual void animate();

private:
  GL::SimpleAnimator *_glSimpleAnimator;
  X3D::WorldCoordTranslator *_translator;
  float _time;
};

}

#endif
