#include "GLSimpleAnimator.h"
#include "GLSimpleAnimatorGeometry3DVisitor.h"

namespace X3DTK {
namespace GL {

SimpleAnimator::SimpleAnimator()
: X3DOnePassProcessor()
{
  //Getting the global variables.
  globalVariables = GVManager::getInstanceOf<SimpleAnimatorGlobalVariables>();
    
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new SimpleAnimatorGeometry3DVisitor());
}

SimpleAnimator::~SimpleAnimator()
{
  GVManager::removeInstanceOf<SimpleAnimatorGlobalVariables>();

  delete graphTraversal;
}

void SimpleAnimator::setBBoxSize(const SFVec3f &size)
{
  globalVariables->setBBoxSize(size);
}

void SimpleAnimator::animate(SFNode N, float time)
{
  // Setting the time.
  globalVariables->setTime(time);
  graphTraversal->traverse(N);
}

}
}
