////////////////////////////////////////////////////////////////////////////////
///                            GLSimpleAnimator.h                            ///
////////////////////////////////////////////////////////////////////////////////

#ifndef GLSIMPLEANIMATOR_H
#define GLSIMPLEANIMATOR_H

#include "GLSimpleAnimatorGlobalVariables.h"

#include <X3DTK/glscenegraph.h>

namespace X3DTK {
namespace GL {

/// X3DSimpleAnimator concept.

class SimpleAnimator : public X3DOnePassProcessor
{
public:
  /// Constructor.
  SimpleAnimator();
  /// Destructor.
  virtual ~SimpleAnimator();
  
  /// Sets the Bbox size.  
  void setBBoxSize(const SFVec3f &size);
  /// Animates the scene.
  virtual void animate(SFNode N, float time);
 
protected:
  SimpleAnimatorGlobalVariables *globalVariables;
};

}
}

#endif
