/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//  generated by script                                                       //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DTK_KERNEL_H
#define X3DTK_KERNEL_H

//abstractNode
#include "private/Component.h"
#include "private/NameDict.h"
#include "private/SceneGraph.h"
#include "private/Type.h"
#include "private/X3DAbstractNode.h"

//image
#include "private/Image.h"
#include "private/JPGImageType.h"
#include "private/X3DImageType.h"

//processor
#include "private/AbstractVisitor.h"
#include "private/AbstractWalker.h"
#include "private/EnterFunction.h"
#include "private/GlobalVariables.h"
#include "private/GraphTraversal.h"
#include "private/GVManager.h"
#include "private/LeaveFunction.h"
#include "private/VisitingFunctions.h"
#include "private/Visitor.h"
#include "private/Walker.h"
#include "private/WalkingFunction.h"
#include "private/WalkOnFunction.h"
#include "private/X3DActiveFunction.h"
#include "private/X3DActor.h"
#include "private/X3DComponent.h"
#include "private/X3DComponentVisitor.h"
#include "private/X3DComponentWalker.h"
#include "private/X3DFunction.h"
#include "private/X3DOnePassProcessor.h"
#include "private/X3DProcessor.h"

//types
#include "private/BBox.h"
#include "private/CLog.h"
#include "private/libXMLFileElement.h"
#include "private/Platform.h"
#include "private/QFileElement.h"
#include "private/SFMatrix34f.h"
#include "private/SFPoint3f.h"
#include "private/SFString.h"
#include "private/SFVec2f.h"
#include "private/SFVec3f.h"
#include "private/X3DBaseTypes.h"
#include "private/X3DFileElement.h"
#include "private/X3DSceneGraphTypes.h"
#include "private/X3DTypes.h"
#include "private/X3DTypesToSFString.h"
#include "private/XercesFileElement.h"

#endif
