/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            GL_Switch.h                                     //
//////////////////////////////////////////////////////////////////////////////// 

#ifndef GLSWITCH_H
#define GLSWITCH_H

#include "GL_X3DGroupingNode.h"

namespace X3DTK {
namespace GL {

/// Class providing a implementation of the X3DGLNode corresponding to the X3DNode 
/// Switch.

class Switch : public X3DGroupingNode
{
public:
  /// Constructor.
  Switch();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Destructor.
  virtual ~Switch();

  /// Sets the whichChoice.
  void setWhichChoice(SFInt32 whichChoice);

  /// Gets the whichChoice.
  inline SFInt32 getWhichChoice() const {return _whichChoice;};

  /// Updates the content of the node.
  virtual void update();

protected:
  /// Copy constructor.	
  Switch(const Switch &G);
  
private:
  SFInt32 _whichChoice;  
};

}
}

#endif
