/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            Geometry3DCreator.h                             //
////////////////////////////////////////////////////////////////////////////////

#ifndef GEOMETRY3DCREATOR_H
#define GEOMETRY3DCREATOR_H

#include "X3DComponentCreator.h"

namespace X3DTK {
namespace X3D {

class Box;
class Cone;
class Cylinder;
class IndexedFaceSet;
class Sphere;

/// Concrete component Creator for the geometry3D component defining the  
/// X3D nodes.

class Geometry3DCreator : public X3DComponentCreator
{
public:
  /// Constructor.
  Geometry3DCreator();
  /// Destructor.
  virtual ~Geometry3DCreator();
  
  /// Creates a Box.
  Box *createBox() const;
  /// Creates a Cone.
  Cone *createCone() const;
  /// Creates a Cylinder.
  Cylinder *createCylinder() const;      
  /// Creates a IndexedFaceSet.
  IndexedFaceSet *createIndexedFaceSet() const;
  /// Creates a Sphere.
  Sphere *createSphere() const;

};

}
}

#endif
