/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            TemplateMeshBuilderCoreVisitor.h                //
////////////////////////////////////////////////////////////////////////////////

#ifndef TEMPLATEMESHBUILDERCOREVISITOR_H
#define TEMPLATEMESHBUILDERCOREVISITOR_H

#include "CoreVisitor.h"
#include "TemplateMeshBuilderGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class Scene;
class X3DNode;

/// Visitor for the Core component of the TemplateMeshBuilder processor.

class TemplateMeshBuilderCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  TemplateMeshBuilderCoreVisitor();
  
  /// Destructor.
  virtual ~TemplateMeshBuilderCoreVisitor();
    
  /// Enters a Scene.
  virtual void enterScene(Scene *S) const;
  /// Enters an X3DNode.
  virtual void enterX3DNode(X3DNode *N) const;

  /// Walks on an X3DNode.
  virtual bool walkOnX3DNode(X3DNode *N, SFAbstractNode child) const;
  
  /// Enters a Scene.
  virtual void leaveX3DNode(X3DNode *N) const;

protected:
  TemplateMeshBuilderGlobalVariables *globalVariables;
};

}
}

#endif
