#include "GL_DFSRenderingWalker.h"
#include "GL_X3DComposedGeometryNode.h"
#include "GL_IndexedLineSet.h"
#include "GL_PointSet.h"

namespace X3DTK {
namespace GL {

DFSRenderingWalker::DFSRenderingWalker()
: X3DComponentWalker()
{
  defineComponentName("Rendering", "GL");

  defineNewWalkingFunction(&DFSRenderingWalker::walkX3DComposedGeometryNode);
  defineNewWalkingFunction(&DFSRenderingWalker::walkIndexedLineSet);
  defineNewWalkingFunction(&DFSRenderingWalker::walkPointSet);
}

DFSRenderingWalker::~DFSRenderingWalker()
{
}

void DFSRenderingWalker::walkX3DComposedGeometryNode(X3DComposedGeometryNode *N) const
{
  visitor->enter(N);
  visitor->leave(N);
}

void DFSRenderingWalker::walkIndexedLineSet(IndexedLineSet *I) const
{
  visitor->enter(I);
  visitor->leave(I);
}

void DFSRenderingWalker::walkPointSet(PointSet *P) const
{
  visitor->enter(P);
  visitor->leave(P);
}

}
}
