/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            BoxDrawArray.h                                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef BOXARRAY_H
#define BOXARRAY_H

#include "GLSceneGraphTypes.h"

#include <vector>

namespace X3DTK {
namespace GL {

/// Class providing the arrays required by the opengl command drawElements() to draw
/// a Box.

class BoxDrawArray
{
public:
  /// Gets the CylinderDrawArray of section section.
  static BoxDrawArray *getInstance();
  /// Removes the CylinderDrawArray of section section.
  void removeInstance();

  /// Gets the size of the Box, it means the number of vertices displayed.
  unsigned int getBoxSize() const;
  /// Gets the address of the first element of the vertex array.
  const void *getBoxVertexArrayAddress() const;
  /// Gets the address of the first index.
  const unsigned int *getBoxIndexArrayAddress() const;

private:
  /// Constructor.
  BoxDrawArray();
  
  static int _count;
  static BoxDrawArray *_ref;
  
  std::vector<N3F_V3F> _boxVertexArray;
  std::vector<unsigned int> _boxIndexArray;
};

}
}

#endif
