#include "InterpolationCreator.h"
#include "ColorInterpolator.h"
#include "CoordinateInterpolator.h"
#include "CoordinateInterpolator2D.h"
#include "NormalInterpolator.h"
#include "OrientationInterpolator.h"
#include "PositionInterpolator.h"
#include "PositionInterpolator2D.h"
#include "ScalarInterpolator.h"

namespace X3DTK {
namespace X3D {

InterpolationCreator::InterpolationCreator()
{
  defineComponentName("Interpolation", "X3D");

  defineNewNode<ColorInterpolator>();
  defineNewNode<CoordinateInterpolator>();
  defineNewNode<CoordinateInterpolator2D>();
  defineNewNode<NormalInterpolator>();
  defineNewNode<OrientationInterpolator>();
  defineNewNode<PositionInterpolator>();
  defineNewNode<PositionInterpolator2D>();
  defineNewNode<ScalarInterpolator>();
}

InterpolationCreator::~InterpolationCreator()
{
}

}
}
