#include "RenderingCreator.h"
#include "Color.h"
#include "ColorRGBA.h"
#include "Coordinate.h"
#include "IndexedLineSet.h"
#include "Normal.h"
#include "PointSet.h"
#include "TriangleFanSet.h"
#include "TriangleSet.h"
#include "TriangleStripSet.h"

namespace X3DTK {
namespace X3D {

RenderingCreator::RenderingCreator()
{
  defineComponentName("Rendering", "X3D");

  defineNewNode<Color>();
  defineNewNode<ColorRGBA>();
  defineNewNode<Coordinate>();
  defineNewNode<IndexedLineSet>();
  defineNewNode<Normal>();
  defineNewNode<PointSet>();
  defineNewNode<TriangleFanSet>();
  defineNewNode<TriangleSet>();
  defineNewNode<TriangleStripSet>();
}

RenderingCreator::~RenderingCreator()
{
}

}
}
