#include "DFSGroupingWalker.h"
#include "StaticGroup.h"
#include "X3DGroupingNode.h"

#include <iostream>
using namespace std;


namespace X3DTK {
namespace X3D {

DFSGroupingWalker::DFSGroupingWalker()
: X3DComponentWalker()
{
  defineComponentName("Grouping", "X3D");
  
  defineNewWalkingFunction(&DFSGroupingWalker::walkStaticGroup);
  defineNewWalkingFunction(&DFSGroupingWalker::walkX3DGroupingNode);
}

DFSGroupingWalker::~DFSGroupingWalker()
{
}

void DFSGroupingWalker::walkStaticGroup(StaticGroup *G) const
{
  visitor->enter(G);
  
  MFNode children = G->getChildren();
  for (MFNode::iterator it = children.begin(); it != children.end(); ++it)
    if ((*it != 0) && (visitor->walkOn(G, *it)))
      walker->walk(*it);
  
  visitor->leave(G);
}

void DFSGroupingWalker::walkX3DGroupingNode(X3DGroupingNode *N) const
{
  visitor->enter(N);
  
  MFNode children = N->getChildren();
  for (MFNode::iterator it = children.begin(); it != children.end(); ++it)
    if ((*it != 0) && (visitor->walkOn(N, *it)))
      walker->walk(*it);
  
  visitor->leave(N);
}

}
}
