#include "DFSShapeWalker.h"
#include "X3DShapeNode.h"
#include "Appearance.h"

#include <iostream>
using namespace std;

namespace X3DTK {
namespace X3D {

DFSShapeWalker::DFSShapeWalker()
: X3DComponentWalker()
{
  defineComponentName("Shape", "X3D");
  
  defineNewWalkingFunction(&DFSShapeWalker::walkX3DShapeNode);  
  defineNewWalkingFunction(&DFSShapeWalker::walkAppearance);  
}

DFSShapeWalker::~DFSShapeWalker()
{
}

void DFSShapeWalker::walkX3DShapeNode(X3DShapeNode *N) const
{
  visitor->enter(N);
  
  SFNode C;
  C = N->getAppearance();
  if ((C != 0) && (visitor->walkOn(N, C)))
    walker->walk(C);
  
  C = N->getGeometry();
  if ((C != 0) && (visitor->walkOn(N, C)))
    walker->walk(C);
    
  visitor->leave(N);
}

void DFSShapeWalker::walkAppearance(Appearance *A) const
{
  visitor->enter(A);
  
  SFNode C;
  C = A->getMaterial();
  if ((C != 0) && (visitor->walkOn(A, C)))
    walker->walk(C);
    
  C = A->getTexture();
  if ((C != 0) && (visitor->walkOn(A, C)))
    walker->walk(C);

  C = A->getTextureTransform();
  if ((C != 0) && (visitor->walkOn(A, C)))
    walker->walk(C);

  C = A->getLineProperties();
  if ((C != 0) && (visitor->walkOn(A, C)))
    walker->walk(C);

  C = A->getFillProperties();
  if ((C != 0) && (visitor->walkOn(A, C)))
    walker->walk(C);
    
  visitor->leave(A);
}

}
}
