#include "Contour2D.h"
#include "ContourPolyline2D.h"
#include "NurbsCurve2D.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

Contour2D::Contour2D()
  : X3DGroupingNode(), X3DBoundedObject()
{
  defineTypeName("Contour2D", "NURBS");
}

Contour2D::Contour2D(const Contour2D &N)
  : X3DGroupingNode(N), X3DBoundedObject(N)
{
}

SFNode Contour2D::clone() const
{
  return new Contour2D(*this);
}

Contour2D::~Contour2D()
{
}

bool Contour2D::addChild(const SFAbstractNode &N)
{
  if ( (dynamic_cast<ContourPolyline2D *>(N) != 0) ||
       (dynamic_cast<NurbsCurve2D *>(N) != 0) )
    return X3DGroupingNode::addChild(N);
  
  cerr << "Contour2D::addChild : a node of type " << N->getTypeName() << " cannot be a child!" << endl;
  return false;    
}

bool Contour2D::setChild(const SFAbstractNode &N)
{
  if ( (dynamic_cast<ContourPolyline2D *>(N) != 0) ||
       (dynamic_cast<NurbsCurve2D *>(N) != 0) )
    return X3DGroupingNode::setChild(N);
  
  cerr << "Contour2D::setChild : a node of type " << N->getTypeName() << " cannot be a child!" << endl;
  return false;    
}

}
}
