#include "ContourPolyline2D.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

ContourPolyline2D::ContourPolyline2D()
  : X3DParametricGeometryNode(),
	 _point(MFVec2f())
{
  defineTypeName("ContourPolyline2D", "NURBS");
}

ContourPolyline2D::ContourPolyline2D(const MFVec2f &point)
  : X3DParametricGeometryNode(),
	 _point(point)
{
  defineTypeName("ContourPolyline2D", "NURBS");
}

ContourPolyline2D::ContourPolyline2D(const ContourPolyline2D &N)
  : X3DParametricGeometryNode(N),
	 _point(N._point)
{
}

SFNode ContourPolyline2D::clone() const
{
  return new ContourPolyline2D(*this);
}

ContourPolyline2D::~ContourPolyline2D()
{
}

void ContourPolyline2D::setPoint(const MFVec2f &point)
{
  _point = point;
}

void ContourPolyline2D::load(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("point");
  if (index != -1)
    _point = MFVec2f(element->getAttribute(index));
}

SFString ContourPolyline2D::write() const
{
  SFString attr;
  if (!_point.empty())
    attr += " point=\"" + toSFString(_point) + "\"";
      
  return attr;
}


}
}
