/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            X3DCoordinateNode.h                            //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DCOORDINATENODE_H
#define X3DCOORDINATENODE_H

#include "X3DGeometricPropertyNode.h"

namespace X3DTK {
namespace X3D {

/// Base class of the <a href="../../doc/X3DSpecs/Part01/components/rendering.html">
/// Rendering component</a> defining an X3DCoordinateNode
/// (<a href="../../doc/X3DSpecs/Part01/components/rendering.html#X3DCoordinateNode">
/// documentation</a>).

class X3DCoordinateNode : public X3DGeometricPropertyNode
{
public:  
  /// Constructor.
  X3DCoordinateNode();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~X3DCoordinateNode();

protected:
  /// Constructs an X3DCoordinateNode from its attributes.
  X3DCoordinateNode(const X3DCoordinateNode &N);
};

}
}

#endif
