TEMPLATE = lib 
CONFIG *= staticlib
TARGET = x3dnodes

VPATH = Core \
        Geometry3D \
        Grouping \
        Rendering \
        Shape \
        Texturing \ 
        Interpolation \
        Lighting \
        NURBS 
        
HEADERS = Scene.h \
          X3DNode.h \
	  X3DObject.h \
	  Cylinder.h \
          Cone.h \
	  Sphere.h \
          Box.h \
          IndexedFaceSet.h \
	  X3DBoundedObject.h \
	  X3DChildNode.h \
	  X3DGroupingNode.h \
	  Group.h \
          StaticGroup.h \
	  Transform.h \
          Switch.h \
          Color.h \
          ColorRGBA.h \
          Coordinate.h \
          IndexedLineSet.h \
          Normal.h \
          PointSet.h \
          TriangleFanSet.h \
          TriangleSet.h \
          TriangleStripSet.h \
          X3DColorNode.h \
  	  X3DComposedGeometryNode.h \
          X3DCoordinateNode.h \
          X3DGeometricPropertyNode.h \
          X3DGeometry3DNode.h \
	  X3DGeometryNode.h \
          X3DNormalNode.h \
	  Appearance.h \
	  FillProperties.h \
	  LineProperties.h \
	  Material.h \
	  Shape.h \
	  X3DAppearanceChildNode.h \
	  X3DAppearanceNode.h \
	  X3DMaterialNode.h \
	  X3DShapeNode.h \
	  X3DTextureNode.h \
          X3DTextureCoordinateNode.h \        
	  X3DTextureTransformNode.h \
          X3DTexture2DNode.h \        
          ImageTexture.h \
          TextureCoordinate.h \
          
SOURCES = Scene.cpp \
          X3DNode.cpp \
	  X3DObject.cpp \
	  Cylinder.cpp \
          Cone.cpp \
	  Sphere.cpp \
          Box.cpp \
          IndexedFaceSet.cpp \
	  X3DBoundedObject.cpp \
	  X3DChildNode.cpp \
	  X3DGroupingNode.cpp \
	  Group.cpp \
          StaticGroup.cpp \
	  Transform.cpp \
          Switch.cpp \
          Color.cpp \
          ColorRGBA.cpp \
          Coordinate.cpp \
          IndexedLineSet.cpp \
          Normal.cpp \
          PointSet.cpp \
          TriangleFanSet.cpp \
          TriangleSet.cpp \
          TriangleStripSet.cpp \
          X3DColorNode.cpp \
  	  X3DComposedGeometryNode.cpp \
          X3DCoordinateNode.cpp \
          X3DGeometricPropertyNode.cpp \
          X3DGeometry3DNode.cpp \
	  X3DGeometryNode.cpp \
          X3DNormalNode.cpp \
	  Appearance.cpp \
	  FillProperties.cpp \
	  LineProperties.cpp \
	  Material.cpp \
	  Shape.cpp \
	  X3DAppearanceChildNode.cpp \
	  X3DAppearanceNode.cpp \
	  X3DMaterialNode.cpp \
	  X3DShapeNode.cpp \
	  X3DTextureNode.cpp \
          X3DTextureCoordinateNode.cpp \        
	  X3DTextureTransformNode.cpp \
          X3DTexture2DNode.cpp \        
          ImageTexture.cpp \
          TextureCoordinate.cpp \
# --------------------
#  Lighting component
# --------------------

HEADERS += X3DLightNode.h \
           DirectionalLight.h \
           PointLight.h \
           SpotLight.h

SOURCES += X3DLightNode.cpp \
           DirectionalLight.cpp \
           PointLight.cpp \
           SpotLight.cpp

# -------------------------
#  Interpolation component
# -------------------------

HEADERS += X3DInterpolatorNode.h \
           ColorInterpolator.h \
           CoordinateInterpolator.h \
           CoordinateInterpolator2D.h \
           NormalInterpolator.h \
           OrientationInterpolator.h \
           PositionInterpolator.h \
           PositionInterpolator2D.h \
           ScalarInterpolator.h

SOURCES += X3DInterpolatorNode.cpp \
           ColorInterpolator.cpp \
           CoordinateInterpolator.cpp \
           CoordinateInterpolator2D.cpp \
           NormalInterpolator.cpp \
           OrientationInterpolator.cpp \
           PositionInterpolator.cpp \
           PositionInterpolator2D.cpp \
           ScalarInterpolator.cpp

# -----------------
#  NURBS component
# -----------------

HEADERS += X3DParametricGeometryNode.h \
           Contour2D.h \
           ContourPolyline2D.h \
           #CoordinateDeformer.h \
           NurbsCurve.h \
           NurbsCurve2D.h \
           NurbsGroup.h \
           NurbsPositionInterpolator.h \
           NurbsSurface.h \
           NurbsTextureSurface.h \
           TrimmedSurface.h

SOURCES += X3DParametricGeometryNode.cpp \
           Contour2D.cpp \
           ContourPolyline2D.cpp \
           #CoordinateDeformer.cpp \
           NurbsCurve.cpp \
           NurbsCurve2D.cpp \
           NurbsGroup.cpp \
           NurbsPositionInterpolator.cpp \
           NurbsSurface.cpp \
           NurbsTextureSurface.cpp \
           TrimmedSurface.cpp

include(../../X3DToolKit.pri)

INCLUDEPATH += ../../../include/X3DTK
INCLUDEPATH += ../../../include/X3DTK/private

DESTDIR  = ../../../lib
OBJECTS_DIR = ../../../obj
