/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            BBoxDrawArray.h                                 //
////////////////////////////////////////////////////////////////////////////////

#ifndef BBOXDRAWARRAY_H
#define BBOXDRAWARRAY_H

#include "X3DTypes.h"

#include <vector>

namespace X3DTK {
namespace GL {

/// Class providing the arrays required by the glDrawElements() command for drawing a 
/// Bounding Box with corners.

class BBoxDrawArray
{
public:
  /// Constructor.
  BBoxDrawArray();
  
  /// Gets the size of the Box, it means the number of vertices displayed.
  unsigned int getBBoxSize() const;
  /// Gets the address of the first element of the vertex array.
  const void *getBBoxVertexArrayAddress() const;
  /// Gets the address of the first index.
  const unsigned int *getBBoxIndexArrayAddress() const;

protected:
  const float h;
  MFVec3f _BBoxVertexArray;
  std::vector<unsigned int> _BBoxIndexArray; 
};

}
}

#endif
