#include "GL_Renderer.h"
#include "GL_DFSGraphTraversal.h"
#include "GL_RendererCoreVisitor.h"
#include "GL_RendererGroupingVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace GL {

Renderer::Renderer()
: X3DRenderer()
{
  globalVariables = GVManager::getInstanceOf<RendererGlobalVariables>();

  graphTraversal = new GL::DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new RendererCoreVisitor());
  graphTraversal->setComponentVisitor(new RendererGroupingVisitor());
}

Renderer::~Renderer()
{
  GVManager::removeInstanceOf<RendererGlobalVariables>();

  delete graphTraversal;
}

void Renderer::render(X3DNode *N) const
{
  glDisable(GL_COLOR_MATERIAL);
  graphTraversal->traverse(N);
}

}
}
