#include "GL_RendererGroupingVisitor.h"
#include "GL_Group.h"
#include "GL_StaticGroup.h"
#include "GL_Transform.h"

namespace X3DTK {
namespace GL {

RendererGroupingVisitor::RendererGroupingVisitor()
: GroupingVisitor()
{
  // Leave functions
  defineNewLeaveFunction(&RendererGroupingVisitor::leaveTransform);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<RendererGlobalVariables>();
}

RendererGroupingVisitor::~RendererGroupingVisitor()
{
}

void RendererGroupingVisitor::leaveTransform(Transform *) const
{
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();  
}

}
}
