#include "GL_Updater.h"
#include "GL_DFSGraphTraversal.h"
#include "GL_UpdaterCoreVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace GL {

Updater::Updater()
: X3DUpdater()
{
  globalVariables = GVManager::getInstanceOf<UpdaterGlobalVariables>();

  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new UpdaterCoreVisitor());
}

Updater::~Updater()
{
  GVManager::removeInstanceOf<UpdaterGlobalVariables>();

  delete graphTraversal;
}

void Updater::update(X3DNode *N)
{
  graphTraversal->traverse(N);
}

}
}
