#include "MeshNormalUpdater.h"
#include "MeshNormalUpdaterCoreVisitor.h"
#include "MESH_DFSGraphTraversal.h"
#include "MESH_X3DNode.h"

namespace X3DTK {
namespace MESH {

MeshNormalUpdater::MeshNormalUpdater()
: X3DOnePassProcessor()
{
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new MeshNormalUpdaterCoreVisitor());
}

MeshNormalUpdater::~MeshNormalUpdater()
{
  delete graphTraversal;
}

void MeshNormalUpdater::updateNormals(X3DNode *N)
{
  graphTraversal->traverse(N);
}

} 
}
