/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            GLBuilderRenderingVisitor.h                     //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLBUILDERRENDERINGVISITOR_H
#define GLBUILDERRENDERINGVISITOR_H

#include "RenderingVisitor.h"
#include "GLBuilderGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class X3DGeometryNode;
class IndexedLineSet;
class PointSet;
class TriangleFanSet;
class TriangleSet;
class TriangleStripSet;

/// Visitor for the Rendering component of the GLBuilder module.

class GLBuilderRenderingVisitor : public RenderingVisitor
{
public:
  /// Constructor.
  GLBuilderRenderingVisitor();
  /// Destructor.
  virtual ~GLBuilderRenderingVisitor();

  /// enters a IndexedLineSet.
  virtual void enterIndexedLineSet(IndexedLineSet *I) const;
  /// enters a PointSet.
  virtual void enterPointSet(PointSet *P) const;
  /// enters a TriangleFanSet.
  virtual void enterTriangleFanSet(TriangleFanSet *T) const;
  /// enters a TriangleSet.
  virtual void enterTriangleSet(TriangleSet *T) const;
  /// enters a TriangleStripSet.
  virtual void enterTriangleStripSet(TriangleStripSet *T) const;

  /// Walks on an X3DGeometryNode.
  virtual bool walkOnX3DGeometryNode(X3DGeometryNode *N, SFAbstractNode child) const;

protected:
  GLBuilderGlobalVariables *globalVariables;
};

}
}

#endif
