#include "MeshX3DMergerCoreVisitor.h"
#include "Scene.h"
#include "X3DNode.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

MeshX3DMergerCoreVisitor::MeshX3DMergerCoreVisitor()
{
  globalVariables = GVManager::getInstanceOf<MeshX3DMergerGlobalVariables>();
  
  defineNewEnterFunction(&MeshX3DMergerCoreVisitor::enterX3DNode);
  
  defineNewWalkOnFunction(&MeshX3DMergerCoreVisitor::walkOnX3DNode);
  
  defineNewLeaveFunction(&MeshX3DMergerCoreVisitor::leaveScene);  
  defineNewLeaveFunction(&MeshX3DMergerCoreVisitor::leaveX3DNode);
}

MeshX3DMergerCoreVisitor::~MeshX3DMergerCoreVisitor()
{
}

void MeshX3DMergerCoreVisitor::enterX3DNode(X3DNode *N) const
{
  globalVariables->pushParent(N);
}

void MeshX3DMergerCoreVisitor::leaveScene(Scene *S) const
{
  globalVariables->getNextTransform();
  globalVariables->popParent();
}

bool MeshX3DMergerCoreVisitor::walkOnX3DNode(X3DNode *N, SFAbstractNode child) const
{
  return !globalVariables->getExit();
}

void MeshX3DMergerCoreVisitor::leaveX3DNode(X3DNode *N) const
{
  globalVariables->popParent();
}

}
}
