/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            MeshX3DMergerCoreVisitor.h                      //
////////////////////////////////////////////////////////////////////////////////

#ifndef MESHX3DMERGERCOREVISITOR_H
#define MESHX3DMERGERCOREVISITOR_H

#include "CoreVisitor.h"
#include "MeshX3DMergerGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class Scene;
class X3DNode;

/// Visitor for the Grouping component of the MeshX3DMerger module.

class MeshX3DMergerCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  MeshX3DMergerCoreVisitor();
  /// Destructor.
  virtual ~MeshX3DMergerCoreVisitor();

  /// Enters an X3DNode.
  virtual void enterX3DNode(X3DNode *N) const;

  ///Walks on an X3DNode.
  virtual bool walkOnX3DNode(X3DNode *N, SFAbstractNode child) const;

  /// Leaves a Scene.
  virtual void leaveScene(Scene *S) const;
  /// Leaves an X3DNode.
  virtual void leaveX3DNode(X3DNode *N) const;
  
protected:
  MeshX3DMergerGlobalVariables *globalVariables;
};

}
}

#endif
