#include "TemplateMeshBuilderCoreVisitor.h"
#include "Scene.h"
#include "MESH_Scene.h"
#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

TemplateMeshBuilderCoreVisitor::TemplateMeshBuilderCoreVisitor()
: CoreVisitor()
{
  // Enter functions.
  defineNewEnterFunction(&TemplateMeshBuilderCoreVisitor::enterScene);
  defineNewEnterFunction(&TemplateMeshBuilderCoreVisitor::enterX3DNode);
  
  // WalkOn functions.
  defineNewWalkOnFunction(&TemplateMeshBuilderCoreVisitor::walkOnX3DNode);
  
  // Leave functions.
  defineNewLeaveFunction(&TemplateMeshBuilderCoreVisitor::leaveX3DNode);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<TemplateMeshBuilderGlobalVariables>();
};

TemplateMeshBuilderCoreVisitor::~TemplateMeshBuilderCoreVisitor() 
{
};

void TemplateMeshBuilderCoreVisitor::enterScene(Scene *S) const
{
  MESH::SFNode MS = globalVariables->getNode(S);
  if (MS == 0)
  {
    MS = new MESH::Scene();
    globalVariables->addCoupleNode(S, MS);
  }
  globalVariables->pushNode(MS);
};

void TemplateMeshBuilderCoreVisitor::enterX3DNode(X3DNode *) const
{
  globalVariables->pushNode(0);
}

bool TemplateMeshBuilderCoreVisitor::walkOnX3DNode(X3DNode *, SFAbstractNode) const
{
  return (globalVariables->getTop() != 0);
}

void TemplateMeshBuilderCoreVisitor::leaveX3DNode(X3DNode *) const
{
  globalVariables->popNode();
};

}
}
