#include "TemplateMeshBuilderGlobalVariables.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

TemplateMeshBuilderGlobalVariables::TemplateMeshBuilderGlobalVariables()
: GlobalVariables(), _root(0)
{
}

TemplateMeshBuilderGlobalVariables::~TemplateMeshBuilderGlobalVariables()
{
}

void TemplateMeshBuilderGlobalVariables::init()
{
  _root = 0;
  _nodeStack.push_front(0); 
}

void TemplateMeshBuilderGlobalVariables::finish()
{
  _nodeStack.clear();
  _nodeCoupleMap.clear();
}

void TemplateMeshBuilderGlobalVariables::addCoupleNode(SFNode N, MESH::SFNode MN)
{
  _nodeCoupleMap[N] = MN;  
  
  // init root node.
  if (_root == 0)
    _root = MN;
}

void TemplateMeshBuilderGlobalVariables::pushNode(MESH::SFNode N)
{
  MESH::SFNode T = getTop();
  if (T != 0)
    T->addChild(N);

  _nodeStack.push_front(N);
}

void TemplateMeshBuilderGlobalVariables::popNode()
{
  _nodeStack.pop_front();
}

MESH::SFNode TemplateMeshBuilderGlobalVariables::getNode(SFNode N) const
{
  map<SFNode, MESH::SFNode>::const_iterator it = _nodeCoupleMap.find(N);
  if (it != _nodeCoupleMap.end())
    return (*it).second;
    
  return 0;  
}

}
}
