/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            TemplateMeshBuilderShapeVisitor.h               //
////////////////////////////////////////////////////////////////////////////////

#ifndef TEMPLATEMESHBUILDERSHAPEVISITOR_H
#define TEMPLATEMESHBUILDERSHAPEVISITOR_H

#include "ShapeVisitor.h"
#include "TemplateMeshBuilderGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class Shape;

/// Visitor for the Shape component of the TemplateMeshBuilder module.

class TemplateMeshBuilderShapeVisitor : public ShapeVisitor
{
public:
  /// Constructor.
  TemplateMeshBuilderShapeVisitor();
  /// Destructor.
  virtual ~TemplateMeshBuilderShapeVisitor();

  /// Enters a Shape.
  virtual void enterShape(Shape *S) const;

  /// Walks on a Shape.
  virtual bool walkOnShape(Shape *S, SFAbstractNode child) const;

  /// Leaves a Shape.
  virtual void leaveShape(Shape *S) const;

protected:
  TemplateMeshBuilderGlobalVariables *globalVariables;
};

}
}

#endif
