#include "WorldCoordTranslator.h"
#include "WorldCoordTranslatorGroupingVisitor.h"
#include "WorldCoordTranslatorRenderingVisitor.h"
#include "DFSGraphTraversal.h"
#include "X3DNode.h"

namespace X3DTK {
namespace X3D {

WorldCoordTranslator::WorldCoordTranslator()
{
  globalVariables = GVManager::getInstanceOf<WorldCoordTranslatorGlobalVariables>();
    
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new WorldCoordTranslatorGroupingVisitor());
  graphTraversal->setComponentVisitor(new WorldCoordTranslatorRenderingVisitor());
}

WorldCoordTranslator::~WorldCoordTranslator()
{
  GVManager::removeInstanceOf<WorldCoordTranslatorGlobalVariables>();

  delete graphTraversal;
}

void WorldCoordTranslator::translate(SFNode N)
{
  globalVariables->init();
  graphTraversal->traverse(N);
  globalVariables->finish();
}

}
}
