#include "GraphTester.h"
#include "X3DAbstractNode.h"
#include "DFSGraphTraversal.h"
#include "MESH_DFSGraphTraversal.h"
#include "GraphTesterAbstractVisitor.h"

namespace X3DTK {

GraphTester::GraphTester()
{
  globalVariables = GVManager::getInstanceOf<GraphTesterGlobalVariables>();
  
  graphTraversal = mergeGraphTraversals(new X3D::DFSGraphTraversal(), new MESH::DFSGraphTraversal());
  graphTraversal->setComponentVisitor(new GraphTesterAbstractVisitor());
}

GraphTester::~GraphTester()
{
  GVManager::removeInstanceOf<GraphTesterGlobalVariables>();
  
  delete graphTraversal;
}
  
void GraphTester::test(SFAbstractNode N) const
{
  globalVariables->init();
  graphTraversal->traverse(N);
}
  
}
