/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            GraphTesterGlobalVariables.h                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef GRAPHTESTERGLOBALVARIABLES_H
#define GRAPHTESTERGLOBALVARIABLES_H

#include "GlobalVariables.h"

namespace X3DTK {

/// GlobalVariables for the GraphTester module.

class GraphTesterGlobalVariables : public GlobalVariables
{
public:
  /// Constructor.
  GraphTesterGlobalVariables();
  /// Destructor.
  virtual ~GraphTesterGlobalVariables();

  /// Initializes the traversal.
  void init();
  
  inline void addTab() {_tab += "  ";};
  inline void removeTab() {_tab.resize(_tab.size() - 2);};
  inline SFString getTab() const {return _tab;};

private: 
  SFString _tab;
};

}

#endif
