/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            SceneGraph.h                                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef SCENEGRAPH_H
#define SCENEGRAPH_H

#include "X3DTypes.h"

namespace X3DTK {

/// Class representing the concept of SceneGraph. 

class SceneGraph
{
  friend class Component;
  
public:
  /// Gets the SceneGraph of name name.
  static SceneGraph *getSceneGraph(const SFString &name);
  
  /// Returns the name of the SceneGraph.
  inline SFString getName() const {return _name;};
  /// Gets the list of the types.
  inline MFComponent getComponentList() const {return _componentList;};

private:  
  SceneGraph(const SFString &name);
  ~SceneGraph();
  
  /// Adds one type.
  void addComponent(Component *component);
  /// Adds one reference.
  void addOneReference();
  /// Removes one reference of the SceneGraph.
  static void removeOneReference(SceneGraph *SceneGraph);
  
  SFString _name;    
  int _refCount;
  MFComponent _componentList;
  
  static MFSceneGraph _sceneGraphList;
};

}

#endif
