/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            QFileElement.h                                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef QFILEELEMENT_H
#define QFILEELEMENT_H

#include "X3DFileElement.h"

namespace X3DTK {

class QFileElementImplementation;

namespace X3D {

class QSAX2X3DHandler;

}

/// Class providing an implementation of X3DFileElement based upon Xerces.

class QFileElement : public X3DFileElement
{
  friend class X3D::QSAX2X3DHandler;
public:
  /// Gets the name.
  SFString getName() const;
  /// Gets the attribute at the index i.
  SFString getAttribute(int i) const;
  /// Gets the index of the attribute. Returns -1 if doesn't exist.
  int getIndexAttribute(const SFString &attribute) const;
  
private:
  QFileElementImplementation *impl;
  QFileElement(const SFString &name, const void *const attributes);
  ~QFileElement();  
};

}

#endif
