/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            libXMLFileElement.h                             //
////////////////////////////////////////////////////////////////////////////////

#ifndef LIBXMLFILEELEMENT_H
#define LIBXMLFILEELEMENT_H

#include "X3DFileElement.h"

typedef unsigned char xmlChar;

namespace X3DTK {

class libXMLFileElementImplementation;

namespace X3D {
  struct _X3DParseState;
  typedef _X3DParseState X3DParseState;
  extern void x3d_parser_start_element(X3DParseState *, const xmlChar *, const xmlChar **);
}

/// Class providing an implementation of X3DFileElement based upon Xerces.

class libXMLFileElement : public X3DFileElement
{
  //friend void X3D::x3d_parser_start_element(X3DParseState *state, const xmlChar *name, const xmlChar **attrs);
  friend void X3D::x3d_parser_start_element(X3DParseState *state, const xmlChar *, const xmlChar **);
public:
  /// Gets the name.
  SFString getName() const;
  /// Gets the attribute at the index i.
  SFString getAttribute(int i) const;
  /// Gets the index of the attribute. Returns -1 if doesn't exist.
  int getIndexAttribute(const SFString &attribute) const;
  
private:
  libXMLFileElementImplementation *impl;
  libXMLFileElement(const SFString &name, const void *const attributes);
  ~libXMLFileElement();  
};

}

#endif
